<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'EventCard',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <slp-container class="slp-mb-96">
    <div
      v-if="data.header"
      class="slp-flex slp-flex-column slp-justify-content-center slp-flex-column slp-align-items-center slp-mb-32"
      :data-aos="data.header_animation"
      :data-aos-duration="data.header_animation_duration"
      :data-aos-offset="data.header_animation_offset"
    >
      <h2 class="slp-mb-8 slp-text-xxl">{{ data.header }}</h2>
      <p>{{ data.text }}</p>
    </div>
    <SlpRow>
      <SlpColumn
        v-for="card in data.cards"
        :key="card.header"
        :cols="data.column_size"
        class="slp-mb-16"
      >
        <a
          :href="card.href"
          class="event"
          :data-ga-name="card.data_ga_name"
          :data-ga-location="card.data_ga_location"
          :data-aos="card.aos_animation"
          :data-aos-duration="card.aos_duration"
          :data-aos-offset="card.aos_offset"
        >
          <div class="event__wrapper slp-card">
            <div class="event__content">
              <SlpTypography tag="p" variant="body2">{{
                card.event_type
              }}</SlpTypography>
              <SlpTypography tag="p" variant="body3" class="event__date">{{
                card.date
              }}</SlpTypography>
              <SlpTypography
                tag="h3"
                variant="heading4"
                class="slp-mb-16 slp-mt-16"
                >{{ card.header }}</SlpTypography
              >
              <SlpTypography variant="body1" class="event__link"
                >{{ card.link_text }} →</SlpTypography
              >
            </div>
            <div class="event__icon">
              <nuxt-img
                class="event__icon__image"
                :src="card.icon"
                alt=""
                loading="lazy"
                format="webp"
                quality="99"
              />
            </div>
          </div>
        </a>
      </SlpColumn>
    </SlpRow>
  </slp-container>
</template>

<style scoped lang="scss">
.event {
  cursor: pointer;
  display: flex;
  position: relative;
  height: 100%;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-8;
  }

  &:hover {
    .event__icon {
      background: $color-secondary-200;

      &__image {
        filter: invert(96%) sepia(10%) saturate(28%) hue-rotate(341deg)
          brightness(107%) contrast(100%);
      }
    }
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    flex: 1;

    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);

      h3 {
        color: $color-secondary-200;
      }
    }
  }

  &__content {
    p,
    h3 {
      color: $color-text-300;
    }
  }

  &__link {
    margin-top: auto;
  }

  &__icon {
    top: -20px;
    left: 32px;
    position: absolute;
    align-items: center;
    background: #f2f2f2;
    border-radius: 50%;
    display: flex;
    height: 40px;
    justify-content: center;
    padding: 5px;
    transition: 0.3s ease-in-out all;
    width: 40px;

    &__icon__image {
      filter: invert(34%) sepia(100%) saturate(982%) hue-rotate(244deg)
        brightness(93%) contrast(88%);
    }
  }
}
</style>
